VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListWnd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'' Property Editor Active-X Control
''
'' Version 1.0
''
''
'' EditWnd.cls - Simple List Control Class

'' Copyright (C) 2000 The Southern Cross.
'' All Rights Reserved.

'' Unauthorized Commercial Use Strictly Prohibited.
''
Option Explicit

Private m_DC As Long

Private WithEvents m_Font As StdFont
Attribute m_Font.VB_VarHelpID = -1
Private m_lfFont As LOGFONT
Private m_hFont As Long

Public Data As Variant

Public Enum ListBoxStyles
    
    lsBorder = WS_BORDER
    lsThreed = WS_EX_CLIENTEDGE
    
    lsDisableNoScroll = LBS_DISABLENOSCROLL
    lsExtendedSelect = LBS_EXTENDEDSEL
    lsHasStrings = LBS_HASSTRINGS
    lsMulticolumn = LBS_MULTICOLUMN
    lsMultiselect = LBS_MULTIPLESEL
    lsNoData = LBS_NODATA
    lsNoIntegralHeight = LBS_NOINTEGRALHEIGHT
    lsNoRedraw = LBS_NOREDRAW
    lsNotify = LBS_NOTIFY
    lsOwnerDrawFixed = LBS_OWNERDRAWFIXED
    lsOwnerDrawVariable = LBS_OWNERDRAWVARIABLE
    lsSort = LBS_SORT
    lsStandard = (LBS_NOTIFY Or LBS_SORT Or WS_VSCROLL Or WS_BORDER)
    lsUseTabStops = LBS_USETABSTOPS
    lsWantKeyboardInput = LBS_WANTKEYBOARDINPUT
    
    lsVScroll = WS_VSCROLL
    lsHScroll = WS_HSCROLL
    
End Enum

Private m_ThreedBorder As Boolean

Public Name As String

Private m_Visible As Boolean
Private m_Enabled As Boolean

Private m_Style As ListBoxStyles
Private m_Create As CREATESTRUCT

Private m_Rect As RECT

Private m_hWnd As Long
Private m_hWndOwner As Long

Private m_Text As String
Private m_Length As Long

Public Event Click()

Public Event KeyDown(KeyCode As Long, Shift As Long)
Public Event KeyUp(KeyCode As Long, Shift As Long)

Public Event MouseDown(Button As Long, Shift As Long, x As Long, Y As Long)
Public Event MouseUp(Button As Long, Shift As Long, x As Long, Y As Long)
Public Event MouseMove(Button As Long, Shift As Long, x As Long, Y As Long)

Public Event DblClick()
Public Event Change()

Public Event Resize()
Public Event GotFocus()
Public Event LostFocus()

Public Event Paint()

Public Property Get hWnd() As Long
    hWnd = m_hWnd
End Property

Public Sub SetFocus()
    If m_hWnd = 0& Then Exit Sub
    m_GDI_h.SetFocus (m_hWnd)
End Sub

Public Property Get Style() As ListBoxStyles
        
    Style = m_Style
End Property

Public Property Let Style(ByVal vData As ListBoxStyles)
    
    m_Style = vData
    If (m_hWnd = 0&) Then Exit Property
    
    SetWindowLong m_hWnd, GWL_STYLE, m_Style
    
End Property

Public Property Get ThreedBorder() As Boolean
    ThreedBorder = m_ThreedBorder
    
End Property

Public Property Let ThreedBorder(ByVal vData As Boolean)
    
    m_ThreedBorder = vData
    If (m_hWnd = 0&) Then Exit Property
    
    Dim weStyle As Long
    
    weStyle = GetWindowLong(m_hWnd, GWL_EXSTYLE)
    
    If (vData = True) Then
        weStyle = (weStyle Or WS_EX_CLIENTEDGE)
    Else
        weStyle = (weStyle And (-1& Xor WS_EX_CLIENTEDGE))
    End If
    
    SetWindowLong m_hWnd, GWL_EXSTYLE, weStyle
    
End Property

Public Property Get Length() As Long
    
    If (m_hWnd = 0&) Then Exit Property
    
    m_Length = SendMessage(m_hWnd, WM_GETTEXTLENGTH, 0&, ByVal 0&)
    Length = m_Length

End Property

Public Property Get Text() As String
    
    Text = m_Text
    If (m_hWnd = 0&) Then Exit Property
    
    Dim v() As Byte
    
    m_Length = SendMessage(m_hWnd, WM_GETTEXTLENGTH, 0&, ByVal 0&)
    ReDim v(0 To (m_Length + 1))
    SendMessage m_hWnd, WM_GETTEXT, (m_Length + 1), v(0)
    
    m_Text = CStrToString(v)
    Erase v
    
    Text = m_Text

End Property

Public Property Let Text(ByVal vData As String)
        
    If (m_hWnd = 0&) Then Exit Property
    
    Dim v() As Byte
    ReDim v(0 To Len(vData))
    StringToCStr vData, v, False
    
    SendMessage m_hWnd, WM_SETTEXT, Len(vData), v(0)
    m_Text = Text
        
End Property

Public Sub Clear()
    If (m_hWnd = 0&) Then Exit Sub
    
    SendMessage m_hWnd, LB_RESETCONTENT, 0&, ByVal 0&
    
End Sub

Public Property Get ListCount() As Long
    If (m_hWnd = 0&) Then Exit Property
    
    ListCount = SendMessage(m_hWnd, LB_GETCOUNT, 0&, ByVal 0&)
End Property

Public Property Get List(ByVal Index As Long) As String
    If (m_hWnd = 0&) Then Exit Property
    
    Dim b() As Byte, _
        l As Long
        
    l = SendMessage(m_hWnd, LB_GETTEXTLEN, Index, ByVal 0&)
    If l > 0 Then
        ReDim b(0 To l)
        SendMessage m_hWnd, LB_GETTEXT, Index, b(0)
        List = CStrToString(b)
        Erase b
    End If

End Property

Public Property Get ListIndex() As Long
    If m_hWnd = 0& Then
        ListIndex = -2
        Exit Property
    End If
    
    ListIndex = SendMessage(m_hWnd, LB_GETCURSEL, 0&, ByVal 0&)
    
End Property

Public Property Let ListIndex(ByVal vData As Long)
    If (m_hWnd = 0) Then Exit Property
    
    SendMessage m_hWnd, LB_SETCURSEL, vData, ByVal 0&
    
End Property

Public Function AddItem(ByVal ItemText As String, Optional ByVal InsertBefore As Long = -1) As Long
    If (m_hWnd = 0&) Then
        AddItem = -1&
        Exit Function
    End If

    Dim b() As Byte
    
    StringToCStr ItemText, b, False
    AddItem = SendMessage(m_hWnd, LB_INSERTSTRING, InsertBefore, b(0))
    
End Function
Public Property Get Visible() As Boolean
    Visible = m_Visible
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal vData As Boolean)
    
    m_Enabled = vData
    If (m_hWnd = 0&) Then Exit Property
    
    SendMessage m_hWnd, WM_ENABLE, m_Enabled, ByVal 0&
    
End Property

Public Property Let Visible(ByVal vData As Boolean)
    
    m_Visible = vData
    If (m_hWnd = 0&) Then Exit Property
    
    If (m_Visible) Then
        ShowWindow m_hWnd, SW_SHOW
    Else
        ShowWindow m_hWnd, SW_HIDE
    End If
    
End Property

Public Property Get Left() As Long

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    Left = m_Rect.Left

End Property

Public Property Get Top() As Long

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    Top = m_Rect.Top

End Property

Public Property Get Width() As Long

    If (m_hWnd = 0&) Then Exit Property
    
    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    Width = (m_Rect.Right - m_Rect.Left) + 1

End Property

Public Property Get Height() As Long

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    Height = (m_Rect.Bottom - m_Rect.Top) + 1

End Property


Public Property Let Left(ByVal vData As Long)

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    m_Rect.Left = vData
    
    With m_Rect
        SetWindowPos m_hWnd, 0&, _
            .Left, .Top, _
            (.Right - .Left) + 1, (.Bottom - .Top) + 1, 0&
            
    End With

End Property

Public Property Let Top(ByVal vData As Long)

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    m_Rect.Top = vData
    
    With m_Rect
        SetWindowPos m_hWnd, 0&, _
            .Left, .Top, _
            (.Right - .Left) + 1, (.Bottom - .Top) + 1, 0&
            
    End With

End Property

Public Property Let Width(ByVal vData As Long)

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    m_Rect.Right = m_Rect.Left + (vData - 1)
    
    With m_Rect
        SetWindowPos m_hWnd, 0&, _
            .Left, .Top, _
            (.Right - .Left) + 1, (.Bottom - .Top) + 1, 0&
            
    End With

End Property

Public Property Let Height(ByVal vData As Long)

    If (m_hWnd = 0&) Then Exit Property

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    m_Rect.Bottom = m_Rect.Top + (vData - 1)
    
    With m_Rect
        SetWindowPos m_hWnd, 0&, _
            .Left, .Top, _
            (.Right - .Left) + 1, (.Bottom - .Top) + 1, 0&
            
    End With

End Property

Public Property Get Font() As StdFont
    Set Font = m_Font
End Property

Public Property Set Font(ByVal vData As StdFont)
    Set m_Font = vData
        
    DoSetFont
                
End Property

Public Property Get Owner() As Long
    Owner = m_hWndOwner
End Property

Public Sub Move(Left, Top, Optional Width, Optional Height)

    GetWindowRect m_hWnd, m_Rect
    AbsToCli m_Rect
    
    m_Rect.Left = Left
    m_Rect.Top = Top
    
    If Not IsEmpty(Width) Then
        m_Rect.Right = m_Rect.Left + (CLng(Width) - 1)
    End If
    
    If Not IsEmpty(Height) Then
        m_Rect.Bottom = m_Rect.Top + (CLng(Height) - 1)
    End If
    
    With m_Rect
        SetWindowPos m_hWnd, 0&, _
            .Left, .Top, _
            (.Right - .Left) + 1, (.Bottom - .Top) + 1, 0&
            
    End With

End Sub

Public Sub Destroy()
    ReleaseDC m_hWnd, m_DC
    m_DC = 0

    RemoveHandle m_hWnd
    RemoveControl m_hWnd
    DestroyWindow m_hWnd
    
    m_hWnd = 0&
End Sub

Public Sub Create(ByVal Parent As Long, ListBoxName As String, x, Y, Optional cx = 60, Optional cy = 16)
    On Error Resume Next
    Dim proc As Long
       
    m_hWndOwner = Parent
    
    With m_Create
    
    .Style = (WS_CHILD Or _
                 (WS_VISIBLE And m_Visible) Or _
                 (WS_DISABLED And (-1& Xor m_Enabled)) Or _
                  WS_TABSTOP Or _
                  m_Style)
                                    
        .x = x
        .Y = Y
        .cx = cx
        .cy = cy
                
        .lpszClass = "LISTBOX"
        .lpszName = ListBoxName
        Name = ListBoxName
        
        .hInstance = App.hInstance
        .hWndParent = m_hWndOwner
        .lpCreateParams = VarPtr(m_Create)
        .ExStyle = (m_ThreedBorder And WS_EX_CLIENTEDGE)
        .hMenu = 0
        
        m_hWnd = CreateWindowEx(.ExStyle, .lpszClass, .lpszName, .Style, .x, .Y, .cx, .cy, .hWndParent, .hMenu, .hInstance, m_Create)
        AddControl m_hWnd, Me
        
        proc = SetWindowLong(m_hWnd, GWL_WNDPROC, AddressOf WndHandleProc)
        AddHandle m_hWnd, proc
        
        SendMessage m_hWnd, WM_SETFONT, m_hFont, ByVal True
        m_DC = GetWindowDC(m_hWnd)
        
    End With
               
End Sub

Private Sub Class_Initialize()
    m_Style = lsStandard
    m_Visible = True
    m_Enabled = True
    
    m_ThreedBorder = True
    
    Set Font = New StdFont
    m_Font.Name = "MS Sans Serif"
    m_Font.SIZE = 8
    
End Sub

Private Sub m_Font_FontChanged(ByVal PropertyName As String)
    DoSetFont
End Sub

Private Sub Class_Terminate()

    If (m_hFont <> 0) Then DeleteObject m_hFont
    Set m_Font = Nothing
    
    If (m_hWnd <> 0&) Then
        Destroy
    End If
    
End Sub

Private Sub DoSetFont()
    
    If (m_hFont <> 0) Then DeleteObject m_hFont
    
    GetLogFont m_Font, m_lfFont, 0&
    m_hFont = CreateFontIndirect(m_lfFont)
    
    If (m_hWnd <> 0&) Then
        SendMessage m_hWnd, WM_SETFONT, m_hFont, ByVal True
    End If

End Sub

Friend Sub FireEvent(ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    Dim lpPoint As POINTAPI

    Dim Button As Long, _
        Shift As Long

    Select Case uMsg
    
        Case WM_PAINT
        
            RaiseEvent Paint
            
        Case WM_KEYUP
        
            RaiseEvent KeyUp(wParam, lParam)
    
        Case WM_KEYDOWN
        
            RaiseEvent KeyDown(wParam, lParam)
    
        Case WM_MOUSEMOVE
                        
            If (wParam And MK_LBUTTON) Then Button = 1
            If (wParam And MK_RBUTTON) Then Button = Button + 2
            If (wParam And MK_MBUTTON) Then Button = Button + 4
            
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseMove(Button, Shift, lpPoint.x, lpPoint.Y)
        
        Case WM_LBUTTONDOWN
                        
            Button = 1
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseDown(Button, Shift, lpPoint.x, lpPoint.Y)
        
        Case WM_RBUTTONDOWN
                        
            Button = 2
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseDown(Button, Shift, lpPoint.x, lpPoint.Y)
        
        Case WM_MBUTTONDOWN
                    
            Button = 4
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseDown(Button, Shift, lpPoint.x, lpPoint.Y)
        
        Case WM_LBUTTONUP
                        
            Button = 1
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseUp(Button, Shift, lpPoint.x, lpPoint.Y)
            RaiseEvent Click
        
        Case WM_RBUTTONUP
                        
            Button = 2
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseUp(Button, Shift, lpPoint.x, lpPoint.Y)
        
        Case WM_MBUTTONUP
                    
            Button = 4
            Shift = (wParam And (MK_SHIFT + MK_CONTROL))
            
            PointFromLong lParam, lpPoint
            RaiseEvent MouseUp(Button, Shift, lpPoint.x, lpPoint.Y)
        
        Case WM_LBUTTONDBLCLK
            
            RaiseEvent DblClick
                            
        Case WM_SIZE
        
            RaiseEvent Resize
            
        Case WM_SETFOCUS
        
            RaiseEvent GotFocus
            
        Case WM_KILLFOCUS
        
            RaiseEvent LostFocus
            
        Case WM_SETTEXT, WM_CHAR, WM_CUT, WM_PASTE
            
            RaiseEvent Change
                                                                    
    End Select
    
End Sub



Private Sub AbsToCli(lpRect As RECT)

    Dim cRect As RECT
    
    GetWindowRect m_hWndOwner, cRect
    
    lpRect.Left = lpRect.Left - cRect.Left
    lpRect.Right = lpRect.Right - cRect.Left
    lpRect.Top = lpRect.Top - cRect.Top
    lpRect.Bottom = lpRect.Bottom - cRect.Top
    
End Sub

Public Property Get hDC() As Long
    hDC = m_DC
End Property
